Skip to main content

Selecting rows

Marking rows as selected

To mark multiple rows as selected, use the selectedRows property.

Example:

<script>
import { getData } from "./common/data";
import { Grid } from "@svar-ui/svelte-grid";

const { data, columns } = getData();

</script>

<Grid {data} {columns} selectedRows={[11,12,15]} />

Related sample: Row selection

Enabling multiple selection

The selection of a single row is enabled by default (a row is selected with the right click). To enable the selection of multiple rows using Shift or Ctrl/Meta and the left click, apply the multiselect property and set its value to true.

Example:

<script>
import { Grid } from "@svar-ui/svelte-grid";
import { getData } from "./common/data";
const { columns, data } = getData();
</script>

<Grid
{data}
columns}
multiselect={true}
/>

Related sample: Multiple row selection

Selecting rows with checkboxes

The example below shows how to select rows by checking Checkboxes within them. Selecting by a row click is disabled.

You can import the ready-made Checkbox control from @svar-ui/svelte-core library and apply it to cells. More information about embedding components to cells you can find here: Adding custom content to cells

Such components receive row data and Grid api among $props. Here the select-row action is called using the api.exec() method when the checkbox changes its value.

<script>
import { Checkbox } from "@svar-ui/svelte-core";
let { row, api } = $props();

function onChange(ev) {
const { value } = ev;
api.exec("select-row", {
id: row.id,
mode: value,
toggle: true,
});
}
</script>

<div data-action="ignore-click">
<Checkbox onchange={onChange} />
</div>

Now what you need is to import the CheckboxCell component and apply it to cells:

<script>
import { Grid } from "@svar-ui/svelte-grid";
import CheckboxCell from "../custom/CheckboxCell.svelte";
import { getData } from "../data";

const { data } = getData();

const columns = [
{ id: "selected", cell: CheckboxCell, width: 36 },
{ id: "city", header: "City", width: 160 },
{ id: "firstName", header: "First Name" },
{ id: "lastName", header: "Last Name" },
{ id: "companyName", header: "Company" },
];
</script>

<div class="demo" style="padding: 20px;">
<div>
<Grid
{data}
{columns}
select={false}
/>
</div>
</div>

Binding checkboxes to selection

The examples below is mostly similar to the above one, but in this case rows can be selected both by clicking on them or checking the checkboxes. Checkbox state changes its state in either ways.

<script>
import { Checkbox } from "@svar-ui/svelte-core";

let { row, api } = $props();
//get the array of currently selected rows
const selectedRows = api.getReactiveState().selectedRows;

function onChange(ev) {
const { value } = ev;

api.exec("select-row", {
id: row.id,
mode: value,
toggle: true,
});
}
</script>

<div data-action="ignore-click">
<Checkbox
onchange={onChange}
value={$selectedRows.indexOf(row.id) !== -1} //bind checkbox state to selection
/>
</div>

Related sample: Selection with checkboxes


Related articles:

Selecting rows
Marking rows as selected
To mark multiple rows as selected, use the selectedRows property.
Example:
import { getData } from "./common/data";
import { Grid } from "@svar-ui/react-grid";
const { data, columns } = getData();
<Grid data={data} columns={columns} selectedRows={[11, 12, 15]} />
Enabling multiple selection
The selection of a single row is enabled by default (a row is selected with the right click). To enable the selection of multiple rows using SHIFT or CTRL and the left click, apply the multiselect property and set its value to true.
Example:
import { Grid } from "@svar-ui/react-grid";
import { getData } from "./common/data";
const { columns, data } = getData();
<Grid 
  data={data}
  columns={columns}
  multiselect={true}
/>
Selecting rows with checkboxes
The example below shows how to select rows by checking Checkboxes within them. Selecting by a row click is disabled.
You can import the ready-made Checkbox control from @svar-ui/react-core library and apply it to cells. More information about embedding components to cells you can find here: Adding custom content to cells
Such components receive row data and Grid api via props (for example: function component signature receives { row, api }). Here the select-row action is called using the api.exec() method when the checkbox changes its value.
Example cell component (CheckboxCell.jsx):
import { Checkbox } from "@svar-ui/react-core";
export default function CheckboxCell({ row, api }) {
  function onChange(ev) {
    const { value } = ev;
    api.exec("select-row", {
      id: row.id,
      mode: value,
      toggle: true,
    });
  }
  return (
    <div data-action="ignore-click">
      <Checkbox onChange={onChange} />
    </div>
  );
}
Now import the CheckboxCell component and apply it to cells:
import { Grid } from "@svar-ui/react-grid";
import CheckboxCell from "../custom/CheckboxCell.jsx";
import { getData } from "../data";
const { data } = getData();
const columns = [
  { id: "selected", cell: CheckboxCell, width: 36 },
  { id: "city", header: "City", width: 160 },
  { id: "firstName", header: "First Name" },
  { id: "lastName", header: "Last Name" },
  { id: "companyName", header: "Company" },
];
<div className="demo" style={{ padding: 20 }}>
  <div>
    <Grid 
      data={data}
      columns={columns}
      select={false}
    />
  </div>
</div>
Binding checkboxes to selection
The example below is mostly similar to the above one, but in this case rows can be selected both by clicking on them or checking the checkboxes. Checkbox state reflects selection in either direction.
Example cell component that binds checkbox state to current selection:
import { Checkbox } from "@svar-ui/react-core";
import { useStore } from "@svar-ui/lib-react";
export default function CheckboxCell({ row, api }) {
  const selectedRows = useStore(api, "selectedRows");
  function onChange(ev) {
    const { value } = ev;
    api.exec("select-row", {
      id: row.id,
      mode: value,
      toggle: true,
    });
  }
  return (
    <div data-action="ignore-click">
      <Checkbox
        onChange={onChange}
        value={selectedRows.indexOf(row.id) !== -1} // bind checkbox state to selection
      />
    </div>
  );
}
Related articles:

Skip to main content

Selecting rows

Marking rows as selected

To mark multiple rows as selected, use the selectedRows property.

Example:

<script setup>
import { getData } from "./common/data";
import { Grid } from "@svar-ui/vue-grid";

const { data, columns } = getData();
</script>

<template>
<Grid :data="data" :columns="columns" :selectedRows="[11,12,15]" />
</template>

Related sample: Row selection

Enabling multiple selection

The selection of a single row is enabled by default (a row is selected with the right click). To enable the selection of multiple rows using Shift or Ctrl/Meta and the left click, apply the multiselect property and set its value to true.

Example:

<script setup>
import { Grid } from "@svar-ui/vue-grid";
import { getData } from "./common/data";
const { columns, data } = getData();
</script>

<template>
<Grid
:data="data"
:columns="columns"
:multiselect="true"
/>
</template>

Related sample: Multiple row selection

Selecting rows with checkboxes

The example below shows how to select rows by checking Checkboxes within them. Selecting by a row click is disabled.

You can import the ready-made Checkbox control from @svar-ui/vue-core library and apply it to cells. More information about embedding components to cells you can find here: Adding custom content to cells

Such components receive row data and Grid api among defineProps. Here the select-row action is called using the api.exec() method when the checkbox changes its value.

<script setup>
import { Checkbox } from "@svar-ui/vue-core";
const props = defineProps({ row: {}, api: {} });

function onChange(ev) {
const { value } = ev;
props.api.exec("select-row", {
id: props.row.id,
mode: value,
toggle: true,
});
}
</script>

<template>
<div data-action="ignore-click">
<Checkbox :onchange="onChange" />
</div>
</template>

Now what you need is to import the CheckboxCell component and apply it to cells:

<script setup>
import { Grid } from "@svar-ui/vue-grid";
import CheckboxCell from "../custom/CheckboxCell.vue";
import { getData } from "../data";

const { data } = getData();

const columns = [
{ id: "selected", cell: CheckboxCell, width: 36 },
{ id: "city", header: "City", width: 160 },
{ id: "firstName", header: "First Name" },
{ id: "lastName", header: "Last Name" },
{ id: "companyName", header: "Company" },
];
</script>

<template>
<div class="demo" style="padding: 20px;">
<div>
<Grid
:data="data"
:columns="columns"
:select="false"
/>
</div>
</div>
</template>

Binding checkboxes to selection

The examples below is mostly similar to the above one, but in this case rows can be selected both by clicking on them or checking the checkboxes. Checkbox state changes its state in either ways.

<script setup>
import { Checkbox } from "@svar-ui/vue-core";
import { computed } from "vue";

const props = defineProps({ row: {}, api: {} });
//get the array of currently selected rows
const selectedRows = props.api.getReactiveState().selectedRows;

function onChange(ev) {
const { value } = ev;

props.api.exec("select-row", {
id: props.row.id,
mode: value,
toggle: true,
});
}

const isSelected = computed(() => selectedRows.value.indexOf(props.row.id) !== -1);
</script>

<template>
<div data-action="ignore-click">
<Checkbox
:onchange="onChange"
:value="isSelected"
/>
</div>
</template>

Related sample: Selection with checkboxes


Related articles: